package me.totalfreedom.totalfreedommod.rank;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import net.luckperms.api.model.user.User;
import net.md_5.bungee.api.ChatColor;
import org.bukkit.entity.Player;

import java.util.Set;

@FunctionalInterface
public interface GroupProvider<T extends DisplayableGroup>
{
    GroupProvider<DisplayableGroup> NON_OP = () -> new DisplayableGroup("non_op", "Non-Ops", "", 0, ChatColor.WHITE, null, false, false);
    GroupProvider<DisplayableGroup> OP = () -> new DisplayableGroup("op", "Operators", "Op", 1, ChatColor.GREEN, null, false, false);
    GroupProvider<DisplayableGroup> MASTER_BUILDER = () -> new DisplayableGroup("builder", "Master Builders", "MB", 2, ChatColor.DARK_AQUA, org.bukkit.ChatColor.DARK_AQUA, true, true);
    GroupProvider<DisplayableGroup> ADMIN = () -> new DisplayableGroup("admin", "Administrators", "Admin", 3, ChatColor.DARK_GREEN, org.bukkit.ChatColor.DARK_GREEN, true, true);
    GroupProvider<DisplayableGroup> SENIOR_ADMIN = () -> new DisplayableGroup("senior", "Senior Administrators", "SrA", 4, ChatColor.GOLD, org.bukkit.ChatColor.GOLD, true, true);

    static User getUser(Player player)
    {
        return TotalFreedomMod.getPlugin()
                .lpb.getAPI()
                .getPlayerAdapter(Player.class)
                .getUser(player);
    }

    static GroupProvider<DisplayableGroup> fromArgument(String arg)
    {
        return switch (arg.toLowerCase())
                {
                    case "op" -> OP;
                    case "builder" -> MASTER_BUILDER;
                    case "admin" -> ADMIN;
                    case "senior" -> SENIOR_ADMIN;
                    default -> NON_OP;
                };
    }

    static Set<GroupProvider<DisplayableGroup>> providerSet() {
        return Set.of(NON_OP, OP, MASTER_BUILDER, ADMIN, SENIOR_ADMIN);
    }

    T getGroup();
}